﻿using UnityEngine;
using System.Collections;

public class CameraController : MonoBehaviour 
{
	public Player player;
	public bool isTrackingMouse;
	public Vector2 currentMousePosition;
	public Vector2 initialMousePosition;

	public float pitch;

	void Start () 
	{
	
	}
	
	void Update () 
	{
		Follow(player.transform);
	
	}

	public void ApplyCameraMovement(Vector2 mousePosition)
	{
		if(!isTrackingMouse)
		{
			isTrackingMouse = true;
			initialMousePosition = mousePosition;
		}
		currentMousePosition = mousePosition;
	}
	
	public void ApplyCameraMovement(float mouseMoveY)
	{
		pitch += mouseMoveY;
		if(pitch < -70f)
		{
			pitch = -70f;
		}
		if(pitch > 70f)
		{
			pitch = 70f;
		}
	}

	public void CancelCameraMovement()
	{
		isTrackingMouse = false;
	}

	private void Follow(Transform playerTransform)
	{
		var charPosition = playerTransform.position + Vector3.up * 1.6f;
		//var cameraMovement = isTrackingMouse ? currentMousePosition - initialMousePosition : Vector2.zero;

		//var quat = Quaternion.Euler(10f + cameraMovement.y * 135f, 0f, 0f);
		var quat = Quaternion.Euler(10f + pitch, 0f, 0f);
		//var quat = Quaternion.Euler(-30.0f - playerTransform.localRotation.x - cameraMovement.y * 135.0f, playerTransform.localRotation.y + 180.0f, 0.0f);
		//var desiredPosition = charPosition;
		//Debug.DrawRay(charPosition, desiredPosition - charPosition);
		
		//var actualPosition = Vector3.Lerp(transform.position, desiredPosition, Time.deltaTime * 2.0f);

		var desiredRotation = playerTransform.localRotation * quat;
		var actualRotation = Quaternion.Lerp(transform.localRotation, desiredRotation, Time.deltaTime * 2.0f);
		
		transform.position = charPosition;
		transform.localRotation = actualRotation;		
	}


}
