﻿using UnityEngine;
using System.Collections.Generic;

public class Messenger : MonoBehaviour 
{
	public GUISkin skin;
	static private Messenger current;

	static public void SetMessage(string message)
	{
		if(current == null)
		{
			current = FindObjectOfType<Messenger>();
		}
		if(current != null)
		{
			current.AddMessage(message);
		}
	}

	public class Message
	{
		public string message;
		public float remainTime;
	}

	public List<Message> messages;

	public void AddMessage(string message, float remainTime)
	{
		var msg = new Message();
		msg.message = message;
		msg.remainTime = remainTime;
		messages.Add(msg);
	}

	public void AddMessage(string message)
	{
		var msg = new Message();
		msg.message = message;
		msg.remainTime = 15f;
		messages.Add(msg);
	}
	
	void Start () 
	{
		messages = new List<Message>();
		AddMessage("One day, you are puttering around in your submarine somewhere beneath the surface of the Atlantic. All of a sudden, three stabilizer rings fall off. Now, everyone knows that a sub can't be piloted without stabilizer rings. You heroically bring the out-of-control sub to rest, on top of a... building?", 30f);
		AddMessage("WASD to move and turn. Q and E to strafe. Mouse controls looking up and down. Space swims upward, and Z swims downward. R activates special powers once obtained.", 60f);

	}

	void Update()
	{
		if(messages == null)
		{
			messages = new List<Message>();
		}
		foreach(var message in messages)
		{
			if(message.remainTime > 0f)
			{
				message.remainTime -= Time.deltaTime;
			}
		}
	}

	void OnGUI () 
	{
		float scaleFactor = Screen.height * 0.001f;
		GUI.matrix = Matrix4x4.TRS (new Vector3(Screen.width * 0.5f, Screen.height * 0.5f, 0.0f), Quaternion.identity, new Vector3 (scaleFactor, scaleFactor, 1.0f)); 
		
		if(skin)
		{
			GUI.skin = skin;
		}
		else
		{
			Debug.Log("GUI skin object missing.");
		}

		float y = -400f;
		foreach(var message in messages)
		{
			if(message.remainTime > 0f)
			{
				if(message.remainTime > 1f)
				{
					GUI.color = Color.white;
				}
				else
				{
					GUI.color = new Color(1f, 1f, 1f, message.remainTime);
				}

				SCGUIUtility.ShadowLabel(new Rect(-500f, y, 1000f, 100f), message.message, "DescriptionCenter");
				y += 150f;
			}
		}

		GUI.color = Color.white;
	
	}
}
