using System;
using UnityEngine;
using System.Collections;

public class TitleGUI : MonoBehaviour {

	public GUISkin skin;
	public float splashTime;
	
	public Texture2D backdrop;

	void OnGUI() 
	{
		float scaleFactor = Screen.height * 0.001f;
		GUI.matrix = Matrix4x4.TRS (new Vector3(Screen.width * 0.5f, Screen.height * 0.5f, 0.0f), Quaternion.identity, new Vector3 (scaleFactor, scaleFactor, 1.0f)); 

		if(skin)
		{
			GUI.skin = skin;
		}
		else
		{
			Debug.Log("GUI skin object missing.");
		}

		GUIStyle backgroundStyle = new GUIStyle();
		backgroundStyle.normal.background = backdrop;
		GUI.Label(new Rect(-888.9f, -500.0f, 1777.8f, 1000.0f), "", backgroundStyle);
		SCGUIUtility.ShadowLabel(new Rect(-500f, -250f, 1000f, 120f), "City Beneath the Surface", "Title");
		
		if(GUI.Button(new Rect(-200f, 70f, 400f, 200f), "Play"))
		{
			SceneManager.LoadScene("Playfield");
		}

		SCGUIUtility.ShadowLabel(new Rect(-775f, 370f, 750f, 60f), "(C) 2014 Smiling Cat Entertainment LTD", "LabelLeft");
		SCGUIUtility.ShadowLabel(new Rect(-775f, 430f, 750f, 60f), "All Rights Reserved", "LabelLeft");

		SCGUIUtility.ShadowLabel(new Rect(475f, 370f, 300f, 60f), Version.versionString, "LabelRight");
		SCGUIUtility.ShadowLabel(new Rect(475f, 430f, 300f, 60f), Version.versionName, "LabelRight");
		
	}
}

