﻿using UnityEngine;
using System.Collections;

public class Prison : MonoBehaviour 
{
	public int keyType = 1;
	public int locks = 7;
	public AudioClip collectSound;

	public string[] unlockMessages;
	public bool wasWelcomed;

	void OnTriggerEnter(Collider other)
	{
		var player = other.GetComponent<Player>();
		if(player != null)
		{
			if(!wasWelcomed)
			{
				AudioSource.PlayClipAtPoint(collectSound, transform.position);
				Messenger.SetMessage(unlockMessages[locks]);
				if(keyType < 4)
				{
					player.AddAir(120f);
				}
				wasWelcomed = true;
			}

			if(player.currentKey == keyType)
			{
				player.DeliverKey();
				locks--;
				Messenger.SetMessage(unlockMessages[locks]);
				AudioSource.PlayClipAtPoint(collectSound, transform.position);

				if(locks == 0 && keyType != 5)
				{
					player.GrantPower(keyType);
					Destroy(this.gameObject);
				}
			}
		}
	}
}
