﻿using UnityEngine;
using System.Collections;

public class Shark : MonoBehaviour 
{
	public float heading;
	public Player player;

	public bool isPursuingPlayer;
	public float speed = 5f;
	public float speedPursuitFactor = 2f;

	public float headingTime;
	public float pursuitCooldown;
	public float pursuitPersistence;
	public Transform eyes;

	void Start () 
	{



	}
	
	void Update () 
	{
		var delta = player.transform.position + Vector3.up - transform.position;
		pursuitCooldown -= Time.deltaTime;

//		var offCooldown = pursuitCooldown <= 0f;
//		var inRange = delta.sqrMagnitude < 400f;
//		var headingValid = headingTime > 0f;
//		var inLOS = PlayerInLOS();
//		Debug.Log("Off Cooldown: " + offCooldown + "; In Range: " + inRange + "; Heading Valid: " + headingValid + "; In LOS: " + inLOS);
//

		if(pursuitCooldown <= 0f && !player.gameIsOver && !player.gameIsWon && !player.isSharkFriend && delta.sqrMagnitude < 400f && headingTime > 0f && PlayerInLOS())
		{
			if(!isPursuingPlayer)
			{
				Messenger.SetMessage("The shark is after you!");
				isPursuingPlayer = true;
				headingTime = 10f;
				pursuitPersistence = 1f;
				audio.Play();
			}
		}
		else
		{
			if(isPursuingPlayer)
			{
				pursuitPersistence -= Time.deltaTime;
				if(pursuitPersistence < 0f)
				{
					isPursuingPlayer = false;
					pursuitCooldown = 10f;
					audio.Stop();
				}
			}
		}
		
		headingTime -= Time.deltaTime;

		if(isPursuingPlayer)
		{
			var delta2D = new Vector2(delta.x, delta.z);
			heading = delta2D.ToAngle();
		}
		else
		{
			if(headingTime < 0f)
			{
				var position2D = new Vector2(transform.position.x, transform.position.z);
				heading = position2D.ToAngle() - 180f +  Random.Range(-50f, 50f);
				//Debug.Log (position2D + ":" + heading);
				headingTime = Random.Range(5f, 15f);
			}

			delta = new Vector3(Mathf.Sin(heading / 180f * Mathf.PI), transform.position.y > 10f ? -0.5f : 0.5f, Mathf.Cos(heading / 180f * Mathf.PI));
		}

		var movement = delta.normalized * speed * (isPursuingPlayer ? speedPursuitFactor : 1f) * Time.deltaTime;
		//Debug.Log(movement);
		transform.position += movement;
		transform.localRotation = Quaternion.Euler(0f, heading, 0f);


	}

	void OnCollisionEnter(Collision collision)
	{
		var player = collision.gameObject.GetComponent<Player>();
		if(player != null && !player.gameIsOver && !player.isSharkFriend)
		{
			player.GetEaten();
		}
		else
		{
			heading -= 180f + Random.Range(-50f, 50f);;
		}
	}

	public bool PlayerInLOS()
	{
		var playerDelta = player.transform.position + Vector3.up - eyes.transform.position;
		RaycastHit hitInfo;
		var ray = new Ray(eyes.position, playerDelta);
		//Debug.DrawRay(ray.origin, playerDelta, Color.red);
		//Debug.Log(ray.origin + ":" + playerDelta);
		if(Physics.Raycast(new Ray(eyes.position, playerDelta), out hitInfo, 20f))
		{
			//Debug.Log("LOS'd a: " + hitInfo.collider.name);
			return hitInfo.collider.GetComponent<Player>() != null;
		}
		return false;
	}
}
