using UnityEngine;
using System.Collections;

public class LoadingStatusGUI : MonoBehaviour 
{
	private const float _totalBytes = 20661774.0f;
	public Texture2D barTexture;
	public bool showSceneStatus;
	public string statusScene;
	public bool showOverallStatus = true;

	public GUISkin skin;

	void OnGUI()
	{
		float scaleFactor = Screen.height * 0.001f;
		GUI.matrix = Matrix4x4.TRS (new Vector3(Screen.width * 0.5f, Screen.height * 0.5f, 0.0f), Quaternion.identity, new Vector3 (scaleFactor, scaleFactor, 1.0f)); 
		Vector2 bottomLeft = new Vector2(-((float)Screen.width / (float)Screen.height) * 500f, 500f);

		if(skin)
		{
			GUI.skin = skin;
		}
		else
		{
			Debug.Log("GUI skin object missing.");
		}

		GUI.depth = -10;

		int bytesLoaded = Application.streamedBytes;
		if(bytesLoaded > 0)
		{
			if(showOverallStatus)
			{
				float percentComplete = Application.GetStreamProgressForLevel(Application.levelCount - 1) * 100.0f;
				if(percentComplete < 100.0f)
				{
					string loadingMessage = "Loading" + "".PadRight((int)(Time.timeSinceLevelLoad % 3.0f) + 1, '.');
					GUI.Label(new Rect(bottomLeft.x, bottomLeft.y - 80f, 320.0f, 80.0f), "", "textArea");
					GUI.Label(new Rect(bottomLeft.x, bottomLeft.y - 80f, 290.0f, 40.0f), loadingMessage, "LabelLeft");
					GUI.Label(new Rect(bottomLeft.x, bottomLeft.y - 80f, 290.0f, 40.0f), percentComplete.ToString("#,##0") + "%", "LabelRight");
					if(barTexture != null)
					{
						float width = 290.0f * percentComplete * 0.01f;
						GUI.DrawTexture(new Rect(bottomLeft.x, bottomLeft.y - 30f, width, 10.0f), barTexture);
					}
				}
			}
			
			if(showSceneStatus)
			{
				float scenePercentComplete = Application.GetStreamProgressForLevel(statusScene) * 100.0f;
				if(scenePercentComplete < 100.0f)
				{
					GUI.Label(new Rect(-300.0f, -80.0f, 600.0f, 160.0f), "", "textArea");
					GUI.Label(new Rect(-300.0f, -80.0f, 600.0f, 160.0f), "", "textArea");
					GUI.Label(new Rect(-200.0f, -80.0f, 400.0f, 80.0f), "Loading...", "Title");
				
					GUI.Label(new Rect(-300.0f, 10.0f, 600.0f, 40.0f), scenePercentComplete.ToString("#,##0") + "%", "LabelCenter");
					if(barTexture != null)
					{
						float width = 570.0f * scenePercentComplete * 0.01f;
						GUI.DrawTexture(new Rect(-285.0f, 55.0f, width, 10.0f), barTexture);
					}
				}
			}
		}
	}

}
