using System;
using UnityEngine;
using System.Collections;

public class SplashGUI : MonoBehaviour {

	public GUISkin skin;
	public Texture2D logo;
	public float splashTime;
	
	private float splashTimer;
	
	public Texture2D backdrop;
	private bool activating;
	private bool activated;
	private string errorMsg;
	private bool switchModes;

	void Start () 
	{
		splashTimer = splashTime;
	}
	
	void Update()
	{
		SceneTransition fader = GetComponent<SceneTransition>();

		splashTimer -= Time.deltaTime;
		
		if(splashTimer < 0.0f)
		{
			SceneManager.LoadScene("Title");
		}
		else
		{
			if(fader.completed)
			{
				fader.Clear();
			}
		}
	}
	
	void OnGUI() 
	{
		float scaleFactor = Screen.height * 0.001f;
		GUI.matrix = Matrix4x4.TRS (new Vector3(Screen.width * 0.5f, Screen.height * 0.5f, 0.0f), Quaternion.identity, new Vector3 (scaleFactor, scaleFactor, 1.0f)); 

		if(skin)
		{
			GUI.skin = skin;
		}
		else
		{
			Debug.Log("GUI skin object missing.");
		}

		GUI.DrawTexture(new Rect(-300.0f, -340.0f, 600.0f, 600.0f), logo);
		GUI.Label(new Rect(-300.0f, 260.0f, 600.0f, 80.0f), "Presents", "LabelLargeCenter");
	}
}
