﻿using UnityEngine;
using System.Collections;

public class SCGUIUtility 
{
	static private Texture2D blankTexture;

	static public Texture2D GetBlankTexture()
	{
		if(blankTexture == null)
		{
			blankTexture = new Texture2D(256, 256, TextureFormat.ARGB32, false);
			var pixels = blankTexture.GetPixels();
			for(int i = 0; i < pixels.Length; i++)
			{
				pixels[i] = new Color(0f, 0f, 0f, 0f);
			}
			blankTexture.SetPixels(pixels);
			blankTexture.Apply();
		}
		return blankTexture;
	}

	static public void ShadowLabel(Rect rect, string text, string styleName)
	{
		var shadowRect = new Rect(rect.x + 3f, rect.y + 3f, rect.width, rect.height);
		var saveColor = GUI.color;
		GUI.color = Color.black;
		GUI.Label(shadowRect, text, styleName);
		GUI.color = saveColor;
		GUI.Label(rect, text, styleName);
	}

	static public void ShadowLabel(Rect rect, GUIContent content, string styleName)
	{
		var shadowRect = new Rect(rect.x + 3f, rect.y + 3f, rect.width, rect.height);
		var shadowContent = new GUIContent(content.text, GetBlankTexture());
		var saveColor = GUI.color;
		GUI.color = Color.black;
		GUI.Label(shadowRect, shadowContent, styleName);
		GUI.color = saveColor;
		GUI.Label(rect, content, styleName);
	}
}
