using UnityEngine;
using System.Collections.Generic;

static internal class Vector2Utility
{
	static internal bool Approximately(this Vector2 value, Vector2 other)
	{
		return value.x.Approximately(other.x) &&
			value.y.Approximately(other.y);
	}

	static internal float ToAngle(this Vector2 value)
	{
		return (float)System.Math.Atan2(value.x, value.y) / Mathf.PI * 180.0f;
	}
	
	static internal string ToStringPrecise(this Vector2 value)
	{
		return string.Format("({0:0.000000}, {1:0.000000})", value.x, value.y);
	}
}
