﻿using UnityEngine;
using System.Collections;

public class ZeusBolt : MonoBehaviour 
{
	public AudioClip collectSound;
	float cooldown;
	
	void Update()
	{
		if(!renderer.enabled)
		{
			cooldown -= Time.deltaTime;
			if(cooldown <= 0f)
			{
				collider.enabled = true;
				renderer.enabled = true;
				particleSystem.enableEmission = true;
			}
		}
	}
	

	void OnTriggerEnter(Collider other)
	{
		var player = other.GetComponent<Player>();
		if(player != null)
		{
			player.GiveZeusBolt();
			AudioSource.PlayClipAtPoint(collectSound, transform.position);
			collider.enabled = false;
			renderer.enabled = false;
			particleSystem.enableEmission = false;
			cooldown = 120f;
		}
	}
}
